# coding: utf-8

"""
    DataCore API  - Sport

    For more details, see openapi/init.py

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the file manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional

from pydantic import BaseModel, Field, StrictStr, constr


class ConferenceExternalIdsPutBody(BaseModel):
    """
    ConferenceExternalIdsPutBody
    """

    conference_id: Optional[StrictStr] = Field(
        None, alias="conferenceId", description="The unique identifier of the conference"
    )
    source: Optional[constr(strict=True, max_length=100)] = Field(None, description="The source of the external Id")
    source_type: Optional[StrictStr] = Field(None, alias="sourceType", description="Source type of external Id")
    source_external_id: Optional[constr(strict=True, max_length=100)] = Field(
        None, alias="sourceExternalId", description="Identifier of external source"
    )
    __properties = ["conferenceId", "source", "sourceType", "sourceExternalId"]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ConferenceExternalIdsPutBody:
        """Create an instance of ConferenceExternalIdsPutBody from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # set to None if conference_id (nullable) is None
        # and __fields_set__ contains the field
        if self.conference_id is None and "conference_id" in self.__fields_set__:
            _dict["conferenceId"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ConferenceExternalIdsPutBody:
        """Create an instance of ConferenceExternalIdsPutBody from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ConferenceExternalIdsPutBody.parse_obj(obj)

        _obj = ConferenceExternalIdsPutBody.parse_obj(
            {
                "conference_id": obj.get("conferenceId"),
                "source": obj.get("source"),
                "source_type": obj.get("sourceType"),
                "source_external_id": obj.get("sourceExternalId"),
            }
        )
        return _obj
