# coding: utf-8

"""
    DataCore API  - Sport

    For more details, see openapi/init.py

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the file manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, Dict, Optional, Union

from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr, constr, validator


class FixturePBPEventPutBody(BaseModel):
    """
    FixturePBPEventPutBody
    """

    events: Optional[Any] = None
    var_class: Optional[constr(strict=True, max_length=100)] = Field(
        "sport",
        alias="class",
        description="The class of the event >- `sport` A sporting action that relates to the running of the fixture ",
    )
    event_type: Optional[constr(strict=True, max_length=100)] = Field(
        None,
        alias="eventType",
        description="See [Event Types](http://developer.connect.sportradar.com/datacore/streaming.html#section/Message-Types/event) for more information",
    )
    event_id: Optional[StrictStr] = Field(None, alias="eventId", description="Unique identifier of this event")
    play_id: Optional[StrictStr] = Field(
        None, alias="playId", description="Unique identifier of this play (group of events)"
    )
    entity_id: Optional[StrictStr] = Field(None, alias="entityId", description="The unique identifier of the entity")
    person_id: Optional[StrictStr] = Field(None, alias="personId", description="The unique identifier of the person")
    sub_type: Optional[constr(strict=True, max_length=100)] = Field(
        None,
        alias="subType",
        description="The Sub Type of event. See <b>Streaming API</b> documenation for more information.",
    )
    options: Optional[Dict[str, Any]] = Field(
        None, description="The options for the event. See <b>Streaming API</b> documenation for more information."
    )
    success: Optional[StrictBool] = Field(None, description="Whether the action was successful")
    x: Optional[Union[StrictFloat, StrictInt]] = Field(
        None, description="The x co-ordinate of the event. Represented as percentage from left (0) to right (100)."
    )
    y: Optional[Union[StrictFloat, StrictInt]] = Field(
        None, description="The y co-ordinate of the event. Represented as precentage from top (0) to bottom (100)."
    )
    z: Optional[Union[StrictFloat, StrictInt]] = Field(
        None, description="The z co-ordinate of the event. Represented as precentage from ground (0) to ceiling (100)."
    )
    clock: Optional[StrictStr] = Field(
        None, description="The time on the clock when the event occurred. ISO 8601 format. PTmmMss.ccS"
    )
    shot_clock: Optional[StrictStr] = Field(
        None,
        alias="shotClock",
        description="The time on the shot clock when the event occurred. ISO 8601 format. PTss.ccS",
    )
    event_time: Optional[datetime] = Field(
        None,
        alias="eventTime",
        description="The date/time (UTC) this event occurred. For inserted actions, this should be the time the action would have occurred, not the time of insertion.",
    )
    official_id: Optional[StrictStr] = Field(
        None, alias="officialId", description="The unique ID of the official making this decision"
    )
    zone: Optional[constr(strict=True, max_length=50)] = Field(
        None, description="See [Event Types]() for more information"
    )
    scores: Optional[Dict[str, constr(strict=True, max_length=50)]] = Field(None, description="The current scores")
    timestamp: Optional[datetime] = Field(None, description="The date/time (UTC) this event was sent.")
    __properties = [
        "events",
        "class",
        "eventType",
        "eventId",
        "playId",
        "entityId",
        "personId",
        "subType",
        "options",
        "success",
        "x",
        "y",
        "z",
        "clock",
        "shotClock",
        "eventTime",
        "officialId",
        "zone",
        "scores",
        "timestamp",
    ]

    @validator("var_class")
    def var_class_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ("sport"):
            raise ValueError("must be one of enum values ('sport')")
        return value

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> FixturePBPEventPutBody:
        """Create an instance of FixturePBPEventPutBody from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # set to None if events (nullable) is None
        # and __fields_set__ contains the field
        if self.events is None and "events" in self.__fields_set__:
            _dict["events"] = None

        # set to None if scores (nullable) is None
        # and __fields_set__ contains the field
        if self.scores is None and "scores" in self.__fields_set__:
            _dict["scores"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> FixturePBPEventPutBody:
        """Create an instance of FixturePBPEventPutBody from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return FixturePBPEventPutBody.parse_obj(obj)

        _obj = FixturePBPEventPutBody.parse_obj(
            {
                "events": obj.get("events"),
                "var_class": obj.get("class") if obj.get("class") is not None else "sport",
                "event_type": obj.get("eventType"),
                "event_id": obj.get("eventId"),
                "play_id": obj.get("playId"),
                "entity_id": obj.get("entityId"),
                "person_id": obj.get("personId"),
                "sub_type": obj.get("subType"),
                "options": obj.get("options"),
                "success": obj.get("success"),
                "x": obj.get("x"),
                "y": obj.get("y"),
                "z": obj.get("z"),
                "clock": obj.get("clock"),
                "shot_clock": obj.get("shotClock"),
                "event_time": obj.get("eventTime"),
                "official_id": obj.get("officialId"),
                "zone": obj.get("zone"),
                "scores": obj.get("scores"),
                "timestamp": obj.get("timestamp"),
            }
        )
        return _obj
