# coding: utf-8

"""
    DataCore API  - Sport

    For more details, see openapi/init.py

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the file manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Optional

from pydantic import BaseModel, Field, StrictStr, constr

from atriumsports.datacore.openapi.models.fixture_progressions_model_season import FixtureProgressionsModelSeason
from atriumsports.datacore.openapi.models.season_external_ids_model_organization import (
    SeasonExternalIdsModelOrganization,
)


class SeasonExternalIdsModel(BaseModel):
    """
    SeasonExternalIdsModel
    """

    season_external_id: Optional[StrictStr] = Field(
        None, alias="seasonExternalId", description="The unique identifier of the external ids"
    )
    organization_id: Optional[StrictStr] = Field(
        None, alias="organizationId", description="The unique identifier of the organization"
    )
    organization: Optional[SeasonExternalIdsModelOrganization] = None
    season_id: Optional[StrictStr] = Field(None, alias="seasonId", description="The unique identifier of the season")
    season: Optional[FixtureProgressionsModelSeason] = None
    source: Optional[constr(strict=True, max_length=100)] = Field(None, description="The source of the external Id")
    source_type: Optional[StrictStr] = Field(None, alias="sourceType", description="Source type of external Id")
    source_external_id: Optional[constr(strict=True, max_length=100)] = Field(
        None, alias="sourceExternalId", description="Identifier of external source"
    )
    updated: Optional[datetime] = Field(None, description="Date/time last modified. In UTC")
    added: Optional[datetime] = Field(None, description="Date/time added. In UTC")
    __properties = [
        "seasonExternalId",
        "organizationId",
        "organization",
        "seasonId",
        "season",
        "source",
        "sourceType",
        "sourceExternalId",
        "updated",
        "added",
    ]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SeasonExternalIdsModel:
        """Create an instance of SeasonExternalIdsModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(
            by_alias=True,
            exclude={
                "organization_id",
                "updated",
                "added",
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of organization
        if self.organization:
            _dict["organization"] = self.organization.to_dict()
        # override the default output from pydantic by calling `to_dict()` of season
        if self.season:
            _dict["season"] = self.season.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SeasonExternalIdsModel:
        """Create an instance of SeasonExternalIdsModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SeasonExternalIdsModel.parse_obj(obj)

        _obj = SeasonExternalIdsModel.parse_obj(
            {
                "season_external_id": obj.get("seasonExternalId"),
                "organization_id": obj.get("organizationId"),
                "organization": SeasonExternalIdsModelOrganization.from_dict(obj.get("organization"))
                if obj.get("organization") is not None
                else None,
                "season_id": obj.get("seasonId"),
                "season": FixtureProgressionsModelSeason.from_dict(obj.get("season"))
                if obj.get("season") is not None
                else None,
                "source": obj.get("source"),
                "source_type": obj.get("sourceType"),
                "source_external_id": obj.get("sourceExternalId"),
                "updated": obj.get("updated"),
                "added": obj.get("added"),
            }
        )
        return _obj
